/*
		JumpToObj.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Class for dialog of same name
*/

#include "stdafx.h"
#include "Cbreak.h"
#include "JumpToObj.h"
#include "World.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// JumpToObj dialog


JumpToObj::JumpToObj(CWnd* pParent /*=NULL*/)
	: CDialog(JumpToObj::IDD, pParent)
{
	//{{AFX_DATA_INIT(JumpToObj)
	m_jump_string = _T("");
	m_new_obj = 0;
	//}}AFX_DATA_INIT
}


void JumpToObj::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(JumpToObj)
	DDX_Text(pDX, IDC_JUMP_WARNING, m_jump_string);
	DDX_Text(pDX, IDC_NEWOBJ, m_new_obj);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(JumpToObj, CDialog)
	//{{AFX_MSG_MAP(JumpToObj)
	ON_EN_CHANGE(IDC_NEWOBJ, OnChangeNewobj)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// JumpToObj message handlers

void JumpToObj::OnOK() 
{
  extern CCbreakApp theApp;
	extern World the_world;
  map<int,Obj>::const_iterator ri;

	if(m_new_obj > 32699 || m_new_obj < 0) {
	  m_jump_string = "Out of Range";
		UpdateData(FALSE);
		return;
	}

	ri = the_world.obj_list.find(m_new_obj);
	if(ri==the_world.obj_list.end()) {
		m_jump_string = "That obj DNE";
		UpdateData(FALSE);
		return;
	}

	theApp.dlg->current_obj = m_new_obj;
	
	theApp.dlg->m_oedit.LoadOedit();

	CDialog::OnOK();
}

void JumpToObj::OnChangeNewobj() 
{
  UpdateData(TRUE);
	
}

BOOL JumpToObj::OnInitDialog() 
{
	CDialog::OnInitDialog();
	
	GetDlgItem(IDC_NEWOBJ)->SetFocus();
	
	return TRUE;
}
