/*
		Obj.cpp : implementation file

        Copyright (C) 2000 Patrick Dughi

        This software may be used and distributed according to the terms
        of the GNU Public License, incorporated herein by reference, located
		as the file gpl.txt in this same directory.

        The author may be reached at dughi@imaxx.net.
.		
		Obj class structure and related functions (load/write/etc)
*/
#pragma warning(disable:4786)
#include "stdafx.h"
#include "Cbreak.h"
#include "Obj.h"
#include "Ex_Desc_Data.h"
#include <vector>
#include <map>
#include <string>
#include "utils.h"

using namespace std;

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

Obj::Obj()
{
  int x;
	for(x=0;x<6;x++) {
		affs[x].atype = -1;
		affs[x].modifier = 0;
	}
	rent=cost=weight=0;
	type=1;

}

Obj::~Obj()
{

}

int Obj::ascii2bitvector(const char *input)
{
  int i;
	int bitvector=0;

	if(isdigit(input[0])) {
		return (atoi(input));
	}
	for(i=0;i<strlen(input);i++) {
		if(input[i] >= 97 && input[i] <= 122) {
			bitvector |= 1 << (input[i] - 'a');
		} else {
			bitvector |= 1 << ((input[i] - 'A')+26);
		}
	}
	return bitvector;
}

void Obj::bitvector2ascii(char *output, int bitvector)
{
  int i, j = 0;
  char *flags="abcdefghijklmnopqrstuvwxyzABCDEF";

  for (i = 0; flags[i] != '\0'; i++) {
	  if (bitvector & (1 << i)) {
        output[j++] = flags[i];
    }
	}

  if (j == 0) {
    output[j++] = '0';
  }

  output[j]='\0';
  return;
}

int Obj::load_obj(CircleFile *cf)
{
  map<int,Zone_Data>::const_iterator zi;
	int found=0,bad=0;
  extern World the_world;
	Ex_Desc_Data *new_desc;
  int zow;
  string temp,temp2;
  

  /* have to verify that each obj is _in_ a zone */
  for(zi=the_world.zone_list.begin();zi!=the_world.zone_list.end() && !found;zi++) {
	  if(zi->first * 100 <= number && zi->second.top >= number) {
		  found=1;
		}
  }

	if(!found) {
		TRACE0(iprintf("Obj %d not found in a zone.\n",number));
		bad=1;
	}
  zone = cf->the_zone;
	cf->tilde_read(&temp);
	alias=temp;
	cf->tilde_read(&temp);
	sdesc=temp;
	cf->tilde_read(&temp);
	ldesc=temp;

	cf->tilde_read(&temp);
	adesc=temp;

	cf->get_line(&temp);
  temp2=temp.substr(0,temp.find(" "));
  type=atoi(temp2.c_str());

  temp = temp.substr(temp.find(" ")+1);
	temp2=temp.substr(0,temp.find(" "));
	effects=ascii2bitvector(temp2.c_str());

  temp = temp.substr(temp.find(" ")+1);
	temp2=temp.substr(0,temp.find(" "));
	wear=ascii2bitvector(temp2.c_str());

	cf->get_line(&temp);
	temp2=temp.substr(0,temp.find(" "));
	value[0]=atoi(temp2.c_str());

  temp = temp.substr(temp.find(" ")+1);
	temp2=temp.substr(0,temp.find(" "));
	value[1]=atoi(temp2.c_str());

  temp = temp.substr(temp.find(" ")+1);
	temp2=temp.substr(0,temp.find(" "));
	value[2]=atoi(temp2.c_str());

  temp = temp.substr(temp.find(" ")+1);
	temp2=temp.substr(0,temp.find(" "));
	value[3]=atoi(temp2.c_str());

	cf->get_line(&temp);
	temp2=temp.substr(0,temp.find(" "));
	weight=atoi(temp2.c_str());

  temp = temp.substr(temp.find(" ")+1);
	temp2=temp.substr(0,temp.find(" "));
	cost=atoi(temp2.c_str());

  temp = temp.substr(temp.find(" ")+1);
	temp2=temp.substr(0,temp.find(" "));
	rent=atoi(temp2.c_str());

	zow=0;
	cf->get_line(&temp);
	while(!temp.empty() && !cf->eof() && temp.at(0) != '#' && temp.at(0) != '$') {
		switch(temp.at(0)) {
			case 'E':
				new_desc = new Ex_Desc_Data;
				cf->tilde_read(&temp);
				new_desc->keyword = temp;
				cf->tilde_read(&temp);
				new_desc->desc = temp;
				exdesc.push_back(*new_desc);
				break;
			case 'A':
				cf->get_line(&temp);
        temp2=temp.substr(0,temp.find(" "));
	      affs[zow].atype=atoi(temp2.c_str());

        temp = temp.substr(temp.find(" ")+1);
	      temp2=temp.substr(0,temp.find(" "));
	      affs[zow++].modifier=atoi(temp2.c_str());
				break;
			default:
				TRACE0(iprintf("An obj default case?..got %s\n",temp.c_str()));
				break;
		}
		cf->get_line(&temp);
	}
	if(!temp.empty() && temp.at(0) == '#') {
		cf->rewind_oneline();
	}
	return TRUE;
}

void Obj::add_exdata(string keywords, string desc)
{
  Ex_Desc_Data *exd;
	delete_exdata(keywords);
	exd = new Ex_Desc_Data;
	exd->desc = desc;
	exd->keyword = keywords;
  exdesc.push_back(*exd); 
}

bool Obj::delete_exdata(string x)
{
	vector<Ex_Desc_Data>::iterator exd;
  for(exd=exdesc.begin();exd != exdesc.end();exd++) {
	  if(exd->keyword == x) {
		  exdesc.erase(exd);
		  return TRUE;
	  }
  }
  return FALSE;

}

Ex_Desc_Data * Obj::get_exdata(int x)
{
	if(exdesc.size() > x ) { 
		return &(exdesc[x]); 
	} 
	return NULL;
}

extern void frigfrag(string *sex);

bool Obj::write_obj(CircleFile *cf)
{
  string obuf;
  string temp;
  char buf[33];
  int i;
  Ex_Desc_Data *tex;

  obuf = iprintf("#%d\n",number);

	obuf += iprintf("%s~\n",alias.c_str());
	obuf += iprintf("%s~\n",sdesc.c_str());
	obuf += iprintf("%s~\n",ldesc.c_str());
	obuf += iprintf("%s~\n",adesc.c_str());

	bitvector2ascii(buf, effects);
  obuf += iprintf("%d %s ",type,buf);
  
	bitvector2ascii(buf, wear);
	obuf+= iprintf("%s\n",buf);

	obuf += iprintf("%d %d %d %d\n",value[0],value[1],value[2],value[3]);
	obuf += iprintf("%d %d %d\n",weight,cost,rent);

  for(i=0;i<get_num_exdata();i++) {
	  tex = get_exdata(i);
	  obuf += "E\n";
	  obuf += iprintf("%s~\n",tex->keyword.c_str());
	  temp=tex->desc.c_str();
	  frigfrag(&temp);
	  obuf += iprintf("%s\n~\n",temp.c_str());
  }

	for(i=0;i<6;i++) {
		if(affs[i].atype > 0) {
			obuf += iprintf("A\n%d %d\n",affs[i].atype,affs[i].modifier);
		}
	}
  return(cf->write_line(&obuf)); 
}

int Obj::get_num_exdata()
{
  return (exdesc.size());
}
